#!/usr/bin/env python3
import subprocess
import pyudev
from gi.repository import GLib
import os
import json

# class RecorderControl(object):
def GetStatus():
    print("this is getstatus")
    if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules'):
        return 0
    elif os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules'):
        return 1
    elif not (os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules') or os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules')):
        return 2

def SetStatus(status):
    print("this is setstatus")
    # 设置管控
    if status == 0:
        print("-----------------设置光盘管控------------------")
        if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules'):
            os.remove('/etc/udev/rules.d/cd-burn-forbid-write.rules')
        if os.path.exists('/etc/udev/rules.d/cd-burn-allow.rules'):
            os.remove('/etc/udev/rules.d/cd-burn-allow.rules')
        if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules'):
            return 0

        context = pyudev.Context()
        sr_list = []
        sr1 = [""]
        try:
            sr = subprocess.getoutput("ls /dev | grep sr").split("\n")
            print("sr = {}".format(sr))
        except Exception:
            print("ls /dev | grep sr -> error")
            pass
        try:
            if sr != sr1:
                print("sr为空")
                for i in sr:
                    zx = pyudev.Devices.from_device_file(context, '/dev/{}'.format(i))
                    b = str(zx)
                    c = b[b.rfind('target'):-12]
                    d = c[12:]
                    e = d.replace(':', ' ').strip("/")
                    sr_list.append(e)
                    # subprocess.getstatusoutput("sudo rm -r /dev/sr{}".format(i))
                    js0bj = json.dumps(sr_list)
                    print("b = " + b);
                    print("c = " + c);
                    print("d = " + d);
                    print("e = " + e);
                    print("s0bj = " + js0bj)
                    try:
                        os.system("sudo umount /dev/{}".format(i))
                        print("sudo umount /dev/{} -> success".format(i))
                    except Exception:
                        print("sudo umount /dev/{} -> error".format(i))
                        pass
                    f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(e)
                    os.system(f)
                    print("f = " + f)
                    with open('/etc/cd.json', 'w') as file:
                        file.write(js0bj)
                        print("write js0bj -> success-1")
            else:
                print("sr不为空")
                b = ""
                with open('/etc/cd.json', 'w') as file:
                    file.write(b)
                    print("write b -> success-2")
        except IndexError:
            b = ""
            with open('/etc/cd.json', 'w') as file:
                file.write(b)
                print("write b -> success-3")

        try:
            with open('/etc/udev/rules.d/cd-burn-forbid-all.rules', 'w') as f:
                f.write('''KERNEL=="sr[0-9]*",RUN+="/bin/cd2.sh"
                        KERNEL=="hd[a-z]",RUN+="/bin/cd2.sh"
                ''')
            print("write cd-burn-forbid-all.rules -> success")

            with open('/etc/udev/rules.d/1cd-burn-forbid-all.rules', 'w') as f:
                f.write('''ACTION=="add",KERNEL=="sr[0-9]*",RUN+="/bin/cd0086.sh"
                        ACTION=="add",KERNEL=="hd[a-z]",RUN+="/bin/cd0086.sh"
                ''')
            print("write 1cd-burn-forbid-all.rules -> success")

            with open('/bin/cd2.sh', 'w') as k:
                k.write('''#!/bin/bash
                        sudo umount /dev/sr*
                        sudo rm -r /dev/sr*
                                        ''')
            print("write /bin/cd2.sh -> success")

            with open('/bin/cd0086.sh', 'w') as k:
                k.write('''#!/bin/bash
                        python3 /etc/cd-re.py
                        sudo umount /dev/sr*
                        sudo rm -r /dev/sr*
                                        ''')
            print("write /bin/cd0086.sh -> success")
        except IOError:
            return -1
        subprocess.getstatusoutput("chmod 555 /bin/cd2.sh")
        subprocess.getstatusoutput("chmod 555 /bin/cd0086.sh")
        subprocess.getstatusoutput("sudo umount /dev/sr*")
        print("chmod 555 -> success")

        return 0
    elif status == 1: # 设置只读
        print("-----------------设置光盘只读------------------")
        if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules'):
            return 0 # 原来就是只读，返回0
        if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules'):
            os.remove('/etc/udev/rules.d/cd-burn-forbid-all.rules')
            asd =1 # 原来是管控
        else:
            asd = 2 # 原来是不管控
        if os.path.exists('/etc/udev/rules.d/1cd-burn-forbid-all.rules'):
            os.remove('/etc/udev/rules.d/1cd-burn-forbid-all.rules')
        if os.path.exists('/etc/udev/rules.d/cd-burn-allow.rules'):
            os.remove('/etc/udev/rules.d/cd-burn-allow.rules')

        with open('/etc/udev/rules.d/cd-burn-forbid-write.rules', 'w') as f:
            f.write('''KERNEL=="sr[0-9]*",RUN+="/bin/cd33.sh"
        KERNEL=="hd[0-9]*",RUN+="/bin/cd33.sh"
        ACTION=="add",KERNEL=="sr[0-9]*",RUN+="/bin/cd33.sh"
        ACTION=="add",KERNEL=="hd[a-z]",RUN+="/bin/cd33.sh"
        ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_FS_USAGE}=="filesystem",RUN+="/bin/cd.sh"
        ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_FS_USAGE}=="filesystem",RUN+="/bin/cd.sh"
        ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_CDROM_MEDIA_STATE}=="blank",RUN+="/bin/cd44.sh"
        ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_CDROM_MEDIA_STATE}=="blank",RUN+="/bin/cd44.sh"
        ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_EJECT_REQUEST}=="1",RUN+="/bin/cd1.sh"
        ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_EJECT_REQUEST}=="1",RUN+="/bin/cd1.sh"
                                            ''')
        print("write cd-burn-forbid-write.rules -> success")
        with open('/bin/cd33.sh', 'w') as k:
            k.write('''#!/bin/bash
                    sudo chmod 444 /dev/sr*
                    sudo systemctl restart cdmonitor.service
                                            ''')
        print("write /bin/cd33.sh -> success")

        with open('/bin/cd44.sh', 'w') as k:
            k.write('''#!/bin/bash
                    sudo chmod 444 /dev/sr*
                    python3 /etc/read_in_blank.py
                                            ''')
        print("write /bin/cd44.sh -> success")

        with open('/bin/cd.sh', 'w') as k:
            k.write('''#!/bin/bash
                    sudo chmod 444 /dev/sr*
                    python3 /etc/read_in.py
                            ''')
        print("write /bin/cd.sh -> success")

        with open('/bin/cd1.sh', 'w') as k:
            k.write('''#!/bin/bash
                    sudo chmod 444 /dev/sr*
                    python3 /etc/read_out.py
                            ''')
        print("write /bin/cd1.sh -> success")
        subprocess.getstatusoutput("chmod 555 /bin/cd.sh")
        subprocess.getstatusoutput("chmod 555 /bin/cd1.sh")
        subprocess.getstatusoutput("chmod 555 /bin/cd33.sh")
        subprocess.getstatusoutput("chmod 555 /bin/cd44.sh")
        print("chmod 555 -> success")
        sr = subprocess.getoutput("ls /dev | grep sr").split("\n")
        print("sr = {}".format(sr))
        t1 = ['']
        if asd == 1:
            print("由管控--->设为只读")
            if sr != t1:
                print("sr列表不为空")
                try:
                    context = pyudev.Context()
                    for i in sr:
                        a = pyudev.Devices.from_device_file(context, '/dev/{}'.format(i))
                        b = str(a)
                        c = b[b.rfind('target'):-12]
                        d = c[12:]
                        e = d.replace(':', ' ').strip("/")
                        print("1")
                        f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(e)
                        g = '''echo "scsi add-single-device {}"> /proc/scsi/scsi'''.format(e)
                        print("b = " + b);
                        print("c = " + c);
                        print("d = " + d);
                        print("e = " + e);
                        print("f = " + f);
                        print("g = " + g);
                        os.system(f)
                        os.system(g)
                except Exception:
                    pass
                os.system("sudo chmod 440 /dev/sr*")
                print("sudo chmod 440 /dev/sr* -> success")
            else:
                print("sr列表为空")
                try:
                    with open('/etc/cd.json', 'r') as f:
                        sr_list = json.load(fp=f)
                    list2 = []
                    if sr_list == list2:
                        pass
                    for k in sr_list:
                        print("2")
                        f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(k)
                        g = '''echo "scsi add-single-device {}"> /proc/scsi/scsi'''.format(k)
                        print("k = " + k);
                        print("f = " + f);
                        print("g = " + g);
                        os.system(f)
                        os.system(g)
                    os.system("chmod 444 /dev/sr*")
                    print("sudo chmod 444 /dev/sr* -> success")
                except Exception:
                    pass
        else:
            print("由不管控--->设为只读")
            if sr != t1:
                try:
                    context = pyudev.Context()
                    for i in sr:
                        a = pyudev.Devices.from_device_file(context, '/dev/{}'.format(i))
                        b = str(a)
                        c = b[b.rfind('target'):-12]
                        d = c[12:]
                        e = d.replace(':', ' ').strip("/")
                        print("3")
                        f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(e)
                        g = '''echo "scsi add-single-device {}"> /proc/scsi/scsi'''.format(e)
                        print("b = " + b);
                        print("c = " + c);
                        print("d = " + d);
                        print("e = " + e);
                        print("f = " + f);
                        print("g = " + g);
                        os.system(f)
                        os.system(g)
                except Exception:
                    pass
                os.system("chmod 440 /dev/sr*")
                print("chmod 440 /dev/sr* -> success-1")
            else:
                os.system("sudo chmod 440 /dev/sr*")
                print("sudo chmod 440 /dev/sr* -> success-2")
                pass
        os.system("sudo chmod 440 /dev/sr*")
        print("sudo chmod 440 /dev/sr* -> success-3")
        return 0
    elif status == 2: #设置不管控
        print("-----------------设置光盘不管控------------------")
        if os.path.exists('/etc/udev/rules.d/cd-burn-allow.rules'):
            return 0
        if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-all.rules'):
            os.remove('/etc/udev/rules.d/cd-burn-forbid-all.rules')
            bsd = 1 # 原来是管控状态--->修改scsi策略
        else:
            bsd = 2 # 原来是只读状态--->只需修改权限
        if os.path.exists('/etc/udev/rules.d/1cd-burn-forbid-all.rules'):
            os.remove('/etc/udev/rules.d/1cd-burn-forbid-all.rules')
        if os.path.exists('/etc/udev/rules.d/cd-burn-forbid-write.rules'):
            os.remove('/etc/udev/rules.d/cd-burn-forbid-write.rules')

        with open('/etc/udev/rules.d/cd-burn-allow.rules', 'w') as f:
            f.write('''ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_FS_USAGE}=="filesystem",RUN+="/etc/normal_in.py"
                    ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_FS_USAGE}=="filesystem",RUN+="/etc/normal_in.py"
                    ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_CDROM_MEDIA_STATE}=="blank",RUN+="/etc/normal_in_blank.py"
                    ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_MEDIA_CHANGE}=="1",ENV{ID_CDROM_MEDIA_STATE}=="blank",RUN+="/etc/normal_in_blank.py"
                    ACTION=="change",KERNEL=="sr[0-9]*",ENV{DISK_EJECT_REQUEST}=="1",RUN+="/etc/normal_out.py"
                    ACTION=="change",KERNEL=="hd[0-9]*",ENV{DISK_EJECT_REQUEST}=="1",RUN+="/etc/normal_out.py"
                                                                                ''')
        print("write cd-burn-allow.rules -> success")
        t2 = ['']
        if bsd == 1:
            print("由管控--->设为不管控")
            sr = subprocess.getoutput("ls /dev | grep sr").split("\n")
            print("sr = {}".format(sr))
            if sr != t2:
                os.system("chmod 666 /dev/sr*")
            else:
                try:
                    with open('/etc/cd.json', 'r') as f:
                        sr_list = json.load(fp=f)
                    print("4")
                    for k in sr_list:
                        f = '''echo "scsi remove-single-device {}"> /proc/scsi/scsi'''.format(k)
                        g = '''echo "scsi add-single-device {}"> /proc/scsi/scsi'''.format(k)
                        print("k = " + k);
                        print("f = " + f);
                        print("g = " + g);
                        os.system(f)
                        os.system(g)
                except Exception:
                    pass
        else:
            print("由只读--->设为管控")
            sr = subprocess.getoutput("ls /dev | grep sr").split("\n")
            print("sr = {}".format(sr))
            if sr != t2:
                os.system("chmod 666 /dev/sr*")
                print("chmod 666 /dev/sr* -> success-1")
            else:
                os.system("chmod 666 /dev/sr*")
                print("chmod 666 /dev/sr* -> success-2")
                pass
        return 0
    else:
        return -1
# if __name__ == '__main__':
#     rectl = RecorderControl()
#     ret = rectl.GetStatus()
#     print(ret)
#     rectl.SetStatus(2)
#     print(ret)